set version 1.7.0

proc debug {line} {
	global debugWindow
	global debug
	if {$debug == "yes"} {
		$debugWindow insert end "$line\n"
	}
}
# 1.5: Show packages
#
package provide app-CatiaStarter 1.0
package require BWidget
package require Tk
package require Tablelist
#source [file join $tablelist::library demos config.tcl]


###########################################
# define base
###########################################
set where_am_i [file dirname $argv0]
set where_am_i [file dirname $where_am_i]
set iStarted 0


# set CLPAutoClose no
set debug "no"
###########################################
# read config file
###########################################

source $where_am_i/config/CLPGeneral.tcl


set CLPFile "$env(HOME)/CATIALaunchPad.txt"
set CLPFile [file nativename $CLPFile]
#::cmdline::getopt argvVar {"-go.arg" "no"} optVar valVar
#set regPath {HKEY_CURRENT_USER\Software\BasicScript Program Settings\STCATIA\Envs}
###########################################
# get the environment info
###########################################
proc getEnv {} {
	global usePersistentEnv
	global regPath
	global os_type
	global CLPFile
	set getEnv ""
	if {$usePersistentEnv} then {
		if {[file exists $CLPFile]} {
			set f1 [open $CLPFile]
			gets $f1 line
			return $line
			close $f1
		}
	}
}
###########################################
# set the environment info
###########################################
proc setEnv {actualEnv addInfo} {
	global catEnvironment
	global usePersistentEnv
	global regPath
	global os_type
	global CLPFile
	if {$usePersistentEnv} then {
		set f1 [open $CLPFile w]
		puts $f1 $catEnvironment
		puts $f1 $addInfo
		close $f1
	}
}
###########################################
# delete the environment info
###########################################
proc delEnv {} {
	global usePersistentEnv
	global regPath
	global os_type
	global CLPFile
	if {$usePersistentEnv} then {
		if {[file exists $CLPFile]} {
			file delete $CLPFile
		}
	}
}

###########################################
# CATIA file specified?
###########################################
set CATIAModel ""
if {[llength $argv] > 0} {
	set CATIAModel "\"[join $argv]\""
}
set CATIAModel [file nativename $CATIAModel]

set catEnvironment [getEnv]

###########################################
# load bitmaps
###########################################
image create photo but_ok 			-file  "$where_am_i/icons/pic_ok.gif"
image create photo but_can 			-file  "$where_am_i/icons/pic_can.gif"
image create photo logo				-file  "$where_am_i/icons/logo.gif"
###########################################
# read config data set
###########################################

set f1 [open "$where_am_i/config/CatiaStarter.cfg" r]
set desc ""
set starterList ""
set addInfo ""
set gifs ""
set lgif ""
set lPackage false
set numHeader 0
set lHeader ""
set header "Configs"
set iRow -1
set iColumn -1

set maxRow 0

set maxDescLen 20

while {![eof $f1]} {
	gets $f1 line

	if {[string range $line 0 0] == "\<" } {
		if {$desc != ""} {
			lappend starterList [list $desc $command $opts $addInfo $gifs $header]
			set desc ""
		}

		set lPackage true
		set endMinusOne [expr [string length $line] - 2]
		set header [string range $line 1 $endMinusOne]
		lappend lHeaderUnique $header
		incr numHeader
		set iRow -1
		incr iColumn
	}

	if {[string range $line 0 0] == "\[" } {

		if { $iColumn == -1 } {set iColumn 0}
		incr iRow
		if {$iRow > $maxRow} {set maxRow $iRow}

		if {$desc != ""} {
			lappend starterList [list $desc $command $opts $addInfo $gifs $header]
		}
		set len [expr [string length $line] -2]

		if {$len > $maxDescLen} then {
			set maxDescLen $len
		}
		set desc [string range $line 1 $len]
		lappend ldesc $desc

		set mTable($iRow,$iColumn,0) $desc

#		tk_messageBox -message $desc

	}
	if {[string range $line 0 7] == "AddInfo=" } {
		set addInfo [string range $line 8 end]
		lappend laddInfo $addInfo
#		tk_messageBox -message $addInfo
	}

	if {[string range $line 0 3] == "Gif=" } {
		set gifs [string range $line 4 end]
		lappend lgif $gifs
#		tk_messageBox -message $addInfo
		set mTable($iRow,$iColumn,1) $gifs
	}

	if {[string range $line 0 7] == "Command=" } {
		set command [string range $line 8 end]
		set command [string map { "\\" "\\\\" } $command]
		set command \"$command\"
		lappend lcommand $command
#		tk_messageBox -message $command
	}
	if {[string range $line 0 7] == "Options=" } {
		set opts [string range $line 8 end]
		set opts [string map { "\\" "\\\\" } $opts ]
		lappend lopts $opts
#		tk_messageBox -message $opts

	}

}
if {$desc != ""} {
	lappend starterList [list $desc $command $opts $addInfo $gifs $header]
	set desc ""
}

if {$numHeader == 0} {set numHeader 1}
close $f1
lappend starterList [list $desc $command $opts $addInfo $gifs]

set lSelect ""
set indexCombo 0
set i 0
#################################################
# display selection for the different environment
#################################################
getEnv

wm title . "Catia Launch Pad $version"
frame .top
frame .showSelected
frame .buttom
pack .top -pady 6
pack .showSelected
pack .buttom

#tk_messageBox -message $MOTD

if {[info exists MOTD]} {
	#insert message of the day
	set f1 [open "$MOTD/index.html"]
	set html [read $f1]
	close $f1
	set fMotd [frame .top.motd]
	set text [text $fMotd.text  -yscrollcommand ".top.motd.scrollbar set" -padx 3 -pady 3 \
				-takefocus 0 -height $motdHeight -width $motdWidth]
	set scroll [scrollbar $fMotd.scrollbar  -command ".top.motd.text yview"  -orient v]
	pack $text -in $fMotd
	pack $fMotd -in .top
	source $where_am_i/bin/html_library.tcl
	HMinit_win  .top.motd.text
	HMparse_html $html "HMrender .top.motd.text"
}

set sw  	[ScrolledWindow 	.top.swlist       	]


if {$numHeader == 1} then {
	lappend colHeader 0
	lappend colHeader "Configs"
	lappend colHeaders "Configs"
} else {
	foreach header $lHeaderUnique {
		lappend colHeader 0
		lappend colHeader $header
	}
}

if {$CATIAModel == ""} {
#	label .top.lab1 -text "Launching without CATIA file"
	label .top.lab1 -text " "
} else {
	label .top.lab1 -text "Launching with: $CATIAModel"
}

pack .top.lab1 -in .top
#pack .top.combo -in .top
pack $sw -in .top


frame .showSelected.f
pack .showSelected.f -in .showSelected
label .showSelected.f.lab -text "Selected:"
pack .showSelected.f.lab -in .showSelected.f


set list_of_frames [tablelist::tablelist $sw.list \
		-columns $colHeader \
		-relief groove -borderwidth 1 \
		-width $widthSelection -height $heightSelection \
		-selectmode single -stretch all -selecttype cell ]

bind [$list_of_frames bodytag] <Button-1> {
	foreach {tablelist::W tablelist::x tablelist::y} \
			[tablelist::convEventFields %W %x %y] {}
			set cIndex [$list_of_frames containingcell $tablelist::x $tablelist::y]
			###---check if available
			if {[array names mTable "$cIndex,0"] !=  ""} {
#				.showSelected.f.lab configure -text "Selected: $mTable([$list_of_frames containingcell $tablelist::x $tablelist::y],0)"
				.showSelected.f.lab configure -text "Selected: $mTable($cIndex,0)"

				set sDescSelected $mTable($cIndex,0)
				set sIndexSelected $cIndex
			}
	}



$sw setwidget $list_of_frames

set i 0
set actCol -1
set actRow 0
set actHeader ""

#tk_messageBox -message [array get mTable]

for {set i 0} {$i <= $maxRow} {incr i} {
	set lRow ""
	for {set j 0} {$j < $numHeader} {incr j} {
		if {[array names mTable "$i,$j,0"] == ""} {
			lappend lRow ""
		} else {
			lappend lRow $mTable($i,$j,0)
		}
	}
	$list_of_frames insert end $lRow
}
# activate given environment
#tk_messageBox -message $catEnvironment
for {set i 0} {$i <= $maxRow} {incr i} {
	set lRow ""
	for {set j 0} {$j < $numHeader} {incr j} {
		if {[array names mTable "$i,$j,0"] !=  ""} {
			if {$mTable($i,$j,0) == $catEnvironment} then {
#			tk_messageBox -message "Activate"
				$list_of_frames cellselection set $i,$j
				set sIndexSelected "$i,$j"

			}
			.showSelected.f.lab configure -text "Selected: $catEnvironment"
			set sDescSelected $catEnvironment

		}
	}
}


# add icons
if {$lgif != ""} then {
	for {set i 0} {$i <= $maxRow} {incr i} {
		set lRow ""
		for {set j 0} {$j < $numHeader} {incr j} {
			if {[array names mTable "$i,$j,1"] == ""} {
	#			$list_of_frames  cellconfigure $i,$j -text ""
			} else {
				image create photo pic_$i\_$j -file  $mTable($i,$j,1)
				$list_of_frames  cellconfigure $i,$j -image pic_$i\_$j
			}
		}
	}
}


#$list_of_frames bindText <Button-1> {
#	menu .menuList
#    .menuList add command -label "Line1" -command {tk_messageBox -message "line1"}
#	tk_popup .menuList %X %Y
#}

#.top.combo setvalue "@$indexCombo"

frame .buttom.logo
frame .buttom.buttons
pack .buttom.logo .buttom.buttons -in .buttom -side left

Button .buttom.buttons.ok -image but_ok -command {
	global iStarted
	global sDescSelected
	global sIndexSelected
	global mTable
	
	global CLPAutoClose
	global CLPConfirmLaunch

	if {$iStarted > 0} {
		set answer [tk_messageBox -message "Already one program started ... continue?" -icon question -type yesno]
	}

	set temp [split $sIndexSelected ","]
	set spalte [lindex $temp 1]
	set zeile [lindex $temp 0]
#	tk_messageBox -message $sIndexSelected
#	tk_messageBox -message [lindex $lHeaderUnique $spalte]

	
	foreach lList $starterList {

		if {([lindex $lList 0] == $sDescSelected) && ([lindex $lList 5] == [lindex $lHeaderUnique $spalte]) } {
			set lStart $lList
		}
	}

	set catCommand [lindex $lStart 1]
	set catOptions [lindex $lStart 2]
	set catEnvironment [lindex $lStart 0]

	.showSelected.f.lab configure -text "Launching ... [lindex $lStart 5]:$catEnvironment"

	set addInfo [lindex $lStart 3]
	setEnv "$catEnvironment" "$addInfo"
	if {$iStarted == 0 || $answer =="yes"} {

		if {$CATIAModel == "" } {
			if {$debug == "yes"} then {
				debug "Calling: $catCommand $catOptions"
			}
			wm iconify .
			catch {set f$iStarted [open "|$catCommand $catOptions"]	} result

			if {$debug == "yes"} then {
				debug "Result: $result"
			}

			if {[string range $result 0 3] != "file"} then {
				tk_messageBox -message $result
			} else {
				while {![eof $result]} {
					gets $result line
					debug $line
				}
				debug "--> Program ended"
				if {$CLPConfirmLaunch == "yes"} {incr iStarted}
			}
			wm deiconify .
	#		catch {exec $catCommand $catOptions}
		} else {
			set catOptions [string map { "\\" "\\\\" } "$catOptions $CATIAModel"]
#			set catOptions "$catOptions $CATIAModel"

#			tk_messageBox -message $catOptions
#			catch {exec $catCommand $catOptions}
			if {$debug == "yes"} then {
				debug "Calling: $catCommand $catOptions"
			}
			wm iconify .
			catch {set f$iStarted [open "|$catCommand $catOptions"]} result
			if {$debug == "yes"} then {
				debug "Result: $result"
			}

			if {[string range $result 0 3] != "file"} then {
				tk_messageBox -message $result
			} else {

				while {![eof $result]} {
					gets $result line
					debug $line
				}

				if {$CLPConfirmLaunch == "yes"} {incr iStarted}

			}
			wm deiconify .
		}
		
	
		if {$CLPAutoClose == "yes"} {exit}
		
	}

}

Button .buttom.buttons.cancel -image but_can -command {
#	delEnv
	global iStarted
	for {set i 0} {$i < $iStarted} {incr i} {
		set channel f$i
		catch {close $channel}
	}
	exit
}
pack .buttom.buttons.ok .buttom.buttons.cancel -in .buttom.buttons
label .buttom.logo.lab1 -image logo
pack .buttom.logo.lab1 -in .buttom.logo

if {$debug == "yes"} then {
	frame .debugFrame
	set debugWindow [text .debugFrame.text  -yscrollcommand ".debugFrame.scrollbar set" -padx 3 -pady 3 \
				-takefocus 0 -height 10 -width 80]
	set scroll [scrollbar .debugFrame.scrollbar  -command ".debug.text yview"  -orient v]
	pack $debugWindow $scroll -in .debugFrame -side left -fill y
	pack .debugFrame
			
}