'---------------------------------------------------------------------------
'  	This script sets the defined milestone on all child nodes (generic nodes only)
'
'	The milestone name is taken from the selected node
'			CN_MILESTONE

'	The Attributes have to be as follows
'
'
'  Multiselction is possible
'  Macro will do that for all levels beginning on the level of the selected node(s)
'
'     Author		: M. Neukirchen
'
'     Notes			: (none)
'	  Version		: 1.0 
'
' (C) Copyright IBM 2004   All Rights Reserved
'---------------------------------------------------------------------------
'  THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED
'  WARRANTY.  ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR
'  PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
'---------------------------------------------------------------------------

'
' Modify  Attribute of Linked Documents
'

Dim Copy_String As Variant
Dim ActualInfo As String

Declare Sub CONV_RecListToComRecordList Lib "Smtdm32" (ByVal RecList As Long,ByRef COMRecList As ISmRecordList)
Declare Sub CONV_ComRecListToRecordList Lib "SmTdm32" (ByVal COMRecList As ISmRecordList,ByRef REcList As Long)

Function CATIA_Edit_Before (ApplHndl As Long,Sstr As String,FirstPar As Long,SecondPar As Long,ThirdPar As Long ) As Integer
	 catia_before_edit = addOemInfo (ApplHndl As Long,Sstr As String,FirstPar As Long,SecondPar As Long,ThirdPar As Long )
End Function

Function mn_env2reg(ApplHndl As Long,Sstr As String,FirstPar As Long,SecondPar As Long,ThirdPar As Long ) As Integer

'RECLST_Print ApplHndl,"FirstPar",FirstPar,0

'Declaration of Variable
	Dim SmSession As ISmSession
	Dim COMFirstList As Object
	Dim COMSecondList As Object
	Dim COMThirdList As Object

	'Get Session from Application handle
	Set SmSession = SCREXT_ObjectForInterface(ApplHndl)
	'Convert Record lists to COM Representation
	CONV_RecListToComRecordList	FirstPar,COMFirstList
	CONV_RecListToComRecordList	SecondPar,COMSecondList
	CONV_RecListToComRecordList	ThirdPar,COMThirdList


	Dim State As Integer
	Dim CATENV As String

	Dim LookUPObj As SmApplic.ISmLookUpObject
	Dim LookUPObjID As Integer
	Dim DocObj As SmApplic.ISmObject
	Dim DocClass As SmApplic.ISmClass
	Dim temp As  ISmObject
	Set DocObj = SmSession.ObjectStore.ObjectFromData(COMFirstList.GetRecord(0),True)
	DocObj.Retrieve

	CATENV = envInfo(DocObj)
	msgbox CATENV
	Call SaveTheEnv(CATENV)

End Function

Function envInfo (obj As ISmObject)  As String
	Set temp = obj.clone
	temp.retrieve
	envInfo = temp.Value("CN_CATENV") 
End Function


Function addOemInfo (ApplHndl As Long,Sstr As String,FirstPar As Long,SecondPar As Long,ThirdPar As Long ) As Integer
	Dim SmSession As ISmSession
	Dim FirstRec  As Object
	Dim SecondRec As Object
	Dim ThirdRec  As Object
	Dim Temp As ISmObject

	On Error GoTo AssignErrorCode 


 '================================Converting procedural script arguments into COM ones===============================

    'Converting ApplHndl to SmSession
    Set SmSession = SCREXT_ObjectForInterface(ApplHndl) 
    'Converting three record lists into COM SmRecordList objects
    CONV_RecListToComRecordList FirstPar,FirstRec 
    CONV_RecListToComRecordList SecondPar,SecondRec
    CONV_RecListToComRecordList ThirdPar,ThirdRec
    
 '================================The Code============================================================================

	'
	' Retrieve selected object
	' input : SmSession, FirstRec													
	' output: SmObject
	'

	Dim cSmObjects As SmApplic.IsmObjects

	Dim itemp1 As Integer
	Dim itemp2 As Integer

	Set cSmObjects = SmSession.ObjectStore.NewObjects()
	Dim CommonGUI As SmGUISrv.SmCommonGUI
	Set CommonGUI = SmSession.GetService("SmGUISrv.SmCommonGUI")
	

	If FirstRec.RecordCount = 0 Then
		MsgBox "No object selected or current object not found in the database"
		GoTo EndFunc
	End If
	Dim SmObject As ISmObject

	For i = 0 To FirstRec.RecordCount - 1
		Set SmObject = SmSession.ObjectStore.ObjectFromData(FirstRec.GetRecord(i),True)
		SmObject.Retrieve
		ActualInfo = GetTheEnv()
		msgbox ActualInfo
		Call doUpdate(SmObject)
	'	inum = cSmObjects.add(SmObject)


		

	'
	' update the CN_ACTUAL_DOCS attribute
	'
		Msg.Open "Updating ...",0,True,True	

		DoEvents

		Call ModifyNodes (SmSession, SmObject, cSmObjects)

		
		Msg.Close
		
	Next 


 '================================Converting COM Variable into procedural script output===============================
    CONV_ComRecListToRecordList ThirdRec,ThirdPar 
   	addOemInfo = Err_None
    Exit Function
  AssignErrorCode : 
    MsgBox Err.Description 
    addOemInfo = Err_Gen  
  EndFunc:
End Function


Sub ModifyNodes(SmSession As Object, SmObject As Object, cSmObjects As SmApplic.IsmObjects)

	SmObject.Retrieve
	'
	' Retrieve links to Documents from the selected object
	' input : SmObject
	' output: Children
	'

	Dim Temp As Object
	Dim QueryDefinition As ISmQueryDefinition
	Dim QueryDefinition1 As ISmQueryDefinition
	Dim iclass As Integer
	Dim ChildMilestone As String
	Dim milestone As String

	Dim SingleChild As ISmObject

'  	Only go for CATProducts, CATParts, CATDrawings nodes
	classOfNode = iclass(SmObject)

'  		Retrieve children of the Object
		Set Children = SmObject.RetrieveChildren(QueryDefinition)
' 		Check for the chidren having the target attribute
		If Not (Children Is Nothing) Then
			Count = Children.Count - 1
						
				num_docs = 	Children.Count
  			
	  			For i = 0 To Count
					Set SingleChild = Children.Item(i)
						
					icl = iclass(SingleChild)
						Set Temp = SingleChild.Clone
						Temp.Retrieve
						Temp.Value("CN_CATENV")  = ActualInfo
						Temp.Update

					Set Children1 = SingleChild.RetrieveChildren(QueryDefinition1)

		   			If Not(children1 Is Nothing) Then
							Call ModifyNodes (SmSession, SingleChild.Clone, cSmObjects)
					End If	
			
				Next


		End If
End Sub

'
'

Function iclass (obj As ISmObject)
	Set temp = obj.clone
	temp.retrieve
	iclass = val(temp.Value("CLASS_ID") )
End Function

Function oemInfo (obj As ISmObject)  As String
	Set temp = obj.clone
	temp.retrieve
	oemInfo = temp.Value("CN_CATENV") 
End Function

Sub doUpdate(obj As ISmObject)
	Set Temp = obj.clone
	Temp.retrieve
	Temp.Value("CN_CATENV")  = ActualInfo
	Temp.Update
End Sub

Function GetTheEnv ()  As String
	fname = Environ$("HOMEDRIVE") & "\" & Environ$("HOMEPATH") & "\CATIALaunchPad.txt"
	'file available?
	If FileExists(fname) Then
		Open fname For Input As #1
		Line Input #1,GetTheEnv
		Close #1
	Else
		GetTheEnv = ""
	End If
End Function

Function SaveTheEnv (environment As String)  As String
	fname = Environ$("HOMEDRIVE") & "\" & Environ$("HOMEPATH") & "\CATIALaunchPad.txt"
	Open fname For Output As #1
	Write #1,environment
	Close #1
End Function
